=== debian/changelog ===
ros-galactic-iceoryx-posh (1.0.0-2focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Eclipse Foundation, Inc. <michael.poehnl@apex.ai>  Tue, 20 Apr 2021 21:37:02 -0000
