=== debian/control ===
Source: ros-galactic-iceoryx-posh
Section: misc
Priority: optional
Maintainer: Eclipse Foundation, Inc. <michael.poehnl@apex.ai>
Build-Depends: debhelper (>= 9.0.0), cmake, git, ros-galactic-iceoryx-utils, ros-galactic-ros-workspace
Homepage: https://iceoryx.io
Standards-Version: 3.9.2

Package: ros-galactic-iceoryx-posh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-ros-workspace
Description: Eclipse iceoryx inter-process-communication (IPC) middleware Posix Shared Memory Library and middleware daemon (RouDi)
